; 

 .586
 .model flat, stdcall
 option casemap :none
 
 include \masm32\include\windows.inc
 include \masm32\include\masm32.inc
 include \masm32\include\user32.inc
 include \masm32\include\kernel32.inc

 includelib \masm32\lib\masm32.lib
 includelib \masm32\lib\user32.lib
 includelib \masm32\lib\kernel32.lib

 include resource.inc
 include linked.inc
 includelib linked.lib

 include \masm32\include\debug.inc
 includelib \masm32\lib\debug.lib

 include \masm32\macros\timers.asm


	testMode		EQU 1
	
	RunTest			PROTO
	Test1			PROTO
	Test2			PROTO
	DialogProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	
MEMBER	STRUCT
	szLabel	db 4 dup (?)
	dwData1	dd ?
	dwData2	dd ?
	dwData3	dd ?

MEMBER	ENDS

.data ; 

	dwMemberCount		dd 10
	dwElementSize		dd 16
	dwSubArrayLen		dd 8
	sText1			db 'Linked list',0Dh,0Ah,0
	sText2			db 'Linked array',0Dh,0Ah,0
	sFormat1		db '  insert time: %ld',0Dh,0Ah,0
	sFormat2		db '  count of members (with sentinels): %ld',0Dh,0Ah,0
	sFormat3		db '  remove time: %ld',0Dh,0Ah,0Dh,0Ah,0
	sTextMem		db 'Size of consumed memory: %ldMB',0Dh,0Ah,0

.data? ; 

	lpMyList		dd ?

	dwMode			dd ?
	dwInsertTime		dd ?

	hInstance		dd ?
	hDlgMain		dd ?
	hEditLog		dd ?

	sBuffer			db 32 dup (?)

.code ; 

 include functions.inc

start:
	invoke GetModuleHandle,NULL
	mov	hInstance,eax
	invoke DialogBoxParam,eax,IDD_MAIN,NULL,offset DialogProc,NULL
	invoke ExitProcess,NULL

DialogProc	PROC hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	eax,uMsg
@WM_INITDIALOG:
		cmp	eax,WM_INITDIALOG
		jnz @WM_COMMAND
			mov	eax,hDlg
			mov	hDlgMain,eax
			invoke LoadIcon,NULL,IDI_ASTERISK
			invoke SendMessage,hDlgMain,WM_SETICON,ICON_SMALL,eax
			invoke GetDlgItem,hDlgMain,IDE_LOG
			mov	hEditLog,eax
			invoke SetDlgItemInt,hDlg,IDE_MEMBERCOUNT,dwMemberCount,FALSE
			invoke SetDlgItemInt,hDlg,IDE_SUBARRAYLEN,dwSubArrayLen,FALSE
			invoke SetDlgItemInt,hDlg,IDE_ELEMENTSIZE,dwElementSize,FALSE
			invoke CheckRadioButton,hDlg,IDC_HEAD,IDC_RND,IDC_HEAD
			invoke CheckDlgButton,hDlg,IDC_LIST,BST_CHECKED
			;mov	eax,1
			jmp @DialogEnd
		; ================================
@WM_COMMAND:
		cmp	eax,WM_COMMAND
		jnz @WM_CLOSE
			mov	ecx,DWORD PTR [wParam+2]
			mov	eax,wParam
			and	ecx,0FFFFh			; notification code
			and	eax,0FFFFh			; control item

			cmp	eax,IDB_RUN
			jnz @IDC_LIST
				cmp	ecx,BN_CLICKED
				jnz @DialogDefault
					mov	dwMode,0
					invoke IsDlgButtonChecked,hDlgMain,IDC_HEAD
					cmp	eax,BST_CHECKED
					jz @F
					mov	dwMode,1
					invoke IsDlgButtonChecked,hDlgMain,IDC_TAIL
					cmp	eax,BST_CHECKED
					jz @F
					mov	dwMode,2
				@@:
					invoke GetDlgItemInt,hDlg,IDE_MEMBERCOUNT,NULL,FALSE
					cmp	eax,10
					jnc @F
						invoke SetDlgItemInt,hDlg,IDE_MEMBERCOUNT,10,FALSE
				@@:
					mov	dwMemberCount,eax
					invoke GetDlgItemInt,hDlg,IDE_SUBARRAYLEN,NULL,FALSE
					cmp	eax,4
					jnc @F
						invoke SetDlgItemInt,hDlg,IDE_SUBARRAYLEN,4,FALSE
				@@:
					mov	dwSubArrayLen,eax
					invoke GetDlgItemInt,hDlg,IDE_ELEMENTSIZE,NULL,FALSE
					cmp	eax,8
					jnc @F
						invoke SetDlgItemInt,hDlg,IDE_ELEMENTSIZE,8,FALSE
				@@:
					mov	dwElementSize,eax

					call RunTests
					mov	eax,1
					jmp @DialogEnd
		@IDC_LIST:
			cmp	eax,IDC_LIST
			jnz @IDC_ARRAY
				invoke IsDlgButtonChecked,hDlgMain,IDC_ARRAY
				cmp	eax,BST_CHECKED
				jz @DialogDefault
				invoke IsDlgButtonChecked,hDlgMain,IDC_LIST
				cmp	eax,BST_CHECKED
				jz @DialogDefault
				invoke CheckDlgButton,hDlgMain,IDC_LIST,BST_CHECKED
				jmp @DialogEnd				
		@IDC_ARRAY:
			cmp	eax,IDC_ARRAY
			jnz @DialogDefault
				invoke IsDlgButtonChecked,hDlgMain,IDC_LIST
				cmp	eax,BST_CHECKED
				jz @DialogDefault
				invoke IsDlgButtonChecked,hDlgMain,IDC_ARRAY
				cmp	eax,BST_CHECKED
				jz @DialogDefault
				invoke CheckDlgButton,hDlgMain,IDC_ARRAY,BST_CHECKED
				jmp @DialogEnd
@WM_CLOSE:	; ================================
		cmp	eax,WM_CLOSE
		jnz @DialogDefault
			invoke EndDialog,hDlgMain,NULL
			jmp @DialogEnd
@DialogDefault:
		xor	eax,eax
@DialogEnd:
		ret
DialogProc	ENDP

end start